## sail 0.9.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(SAIL VERSION 0.9.5
             DESCRIPTION "Squirrel Abstract Image Library"
             LANGUAGES C CXX)

include(GNUInstallDirs)
include(CheckIncludeFiles)
include(CheckCSourceCompiles)
include(CheckCSourceRuns)
include(CMakeDependentOption)
include(CMakePushCheckState)
include(CTest)

# Our own cmake scripts
#
set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake" "${CMAKE_MODULE_PATH}")
include(sail_check_alignas)
include(sail_check_builtin_bswap)
include(sail_check_c11_thread_local)
include(sail_check_include)
include(sail_check_init_once_execute_once)
include(sail_check_openmp)
include(sail_codec)
include(sail_enable_asan)
include(sail_enable_pch)
include(sail_enable_posix_source)
include(sail_enable_xopen_source)
include(sail_install_cmake_config)
include(sail_install_pdb)
include(sail_test)

include(JoinPaths)

# https://github.com/jtojnar/cmake-snips#concatenating-paths-when-building-pkg-config-files
#
join_paths(SAIL_LIBDIR_FOR_PKG_CONFIG     "\${exec_prefix}" "${CMAKE_INSTALL_LIBDIR}")
join_paths(SAIL_INCLUDEDIR_FOR_PKG_CONFIG "\${prefix}"      "${CMAKE_INSTALL_INCLUDEDIR}")

# Check features
#
sail_check_alignas()
sail_check_builtin_bswap()
sail_check_c11_thread_local()

# Check for required includes
#
sail_check_include(ctype.h)
sail_check_include(errno.h)
sail_check_include(setjmp.h)
sail_check_include(stdarg.h)
sail_check_include(stdbool.h)
sail_check_include(stddef.h)
sail_check_include(stdint.h)
sail_check_include(stdio.h)
sail_check_include(stdlib.h)
sail_check_include(string.h)
sail_check_include(sys/stat.h)
sail_check_include(sys/types.h)
sail_check_include(wchar.h)

if (UNIX)
    sail_check_include(dirent.h)
    sail_check_include(dlfcn.h)
    sail_check_include(sys/time.h)
    sail_check_include(unistd.h)
endif()

if (WIN32)
    sail_check_include(io.h)
    sail_check_include(share.h)
    sail_check_include(windows.h)
    sail_check_include("windows.h;versionhelpers.h")
endif()

# Options
#
option(SAIL_BUILD_APPS "Build applications." ON)
option(SAIL_BUILD_EXAMPLES "Build examples." ON)
option(SAIL_DEV "Enable developer mode. Be more strict when compiling source code, for example." OFF)
option(SAIL_ENABLE_OPENMP "Enable OpenMP support if it's available in the compiler." ON)
set(SAIL_ENABLE_CODECS "" CACHE STRING "Forcefully enable the codecs specified in this ';'-separated list. \
If an enabled codec fails to find its dependencies, the configuration process fails. \
One can also specify not just individual codecs but codec groups by their priority like that: highest-priority;xbm. \
Other codecs may or may not be enabled depending on found dependencies. \
When SAIL_ENABLE_CODECS is enabled, SAIL_ONLY_CODECS gets ignored.")
set(SAIL_DISABLE_CODECS "" CACHE STRING "Disable the codecs specified in this ';'-separated list. \
One can also specify not just individual codecs but codec groups by their priority like that: highest-priority;xbm.")
option(SAIL_INSTALL_PDB "Install PDB files along with libraries." ON)
set(SAIL_ONLY_CODECS "" CACHE STRING "Forcefully enable only the codecs specified in this ';'-separated list and disable the rest. \
If an enabled codec fails to find its dependencies, the configuration process fails. \
One can also specify not just individual codecs but codec groups by their priority like that: highest-priority;xbm.")
set(SAIL_OPENMP_SCHEDULE "dynamic" CACHE STRING "OpenMP scheduling algorithm.")
option(BUILD_SHARED_LIBS "Build shared libs. When disabled, sets SAIL_COMBINE_CODECS to ON automatically." ON)
cmake_dependent_option(SAIL_COMBINE_CODECS "Combine all codecs into a single library. When disabled, all codecs are implemented as \
dynamically loaded plugins." OFF "BUILD_SHARED_LIBS" ON)
option(SAIL_THIRD_PARTY_CODECS_PATH "Enable loading third-party codecs from the ';'-separated paths specified in \
the SAIL_THIRD_PARTY_CODECS_PATH environment variable." ON)
option(SAIL_THREAD_SAFE "Enable working in multi-threaded environments by locking the internal context with a mutex." ON)
if (WIN32)
    option(SAIL_WINDOWS_UTF8_PATHS "Convert file paths to UTF-8 on Windows." ON)
endif()

if (SAIL_ENABLE_OPENMP)
    sail_check_openmp()
else()
    set(SAIL_HAVE_OPENMP_DISPLAY "OFF (forced)" CACHE INTERNAL "")
endif()

# When we compile for VCPKG, VCPKG_TARGET_TRIPLET is defined
#
if (VCPKG_TARGET_TRIPLET)
    set(SAIL_VCPKG ON)
else()
    set(SAIL_VCPKG OFF)
endif()

# Number of bytes to read from a file or memory to detect the image
# format by its MIME type.
#
set(SAIL_MAGIC_BUFFER_SIZE 16)

# Our bundled libs
#
if (WIN32 AND NOT SAIL_VCPKG)
    set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} ${PROJECT_SOURCE_DIR}/extra/B)

    # For check_c_source_runs() we need to update PATH
    # so checks are able to find bundled libs
    #
    set(EXTRA_LIBS "${PROJECT_SOURCE_DIR}/extra/B/bin")
    string(REPLACE "/" "\\" EXTRA_LIBS "${EXTRA_LIBS}")
    set(ENV{PATH} "$ENV{PATH};${EXTRA_LIBS}")
endif()

# Enable strict C11
#
set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_C_EXTENSIONS OFF)

# Enable strict C++11
#
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Build position-independent targets
#
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Internal flag used to include SAIL headers locally with "header.h" or <sail/header.h> otherwise
#
add_definitions(-DSAIL_BUILD)

if (SAIL_DEV)
    add_definitions(-DSAIL_DEV)
endif()

# Enable as many warnings as possible
#
if (MSVC)
    if (CMAKE_C_FLAGS MATCHES "/W[0-4]")
        string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")
        string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
    else()
        string(APPEND CMAKE_C_FLAGS " " "/W4")
        string(APPEND CMAKE_CXX_FLAGS " " "/W4")
    endif()
elseif (CMAKE_C_COMPILER_ID STREQUAL "GNU" OR CMAKE_C_COMPILER_ID MATCHES "Clang")
    string(APPEND CMAKE_C_FLAGS " " "-Wall -Wextra")
    string(APPEND CMAKE_CXX_FLAGS " " "-Wall -Wextra")

    if (SAIL_DEV)
        string(APPEND CMAKE_C_FLAGS " " "-pedantic")
        string(APPEND CMAKE_CXX_FLAGS " " "-pedantic")
    endif()
endif()

# Disable undefined symbols
#
if (CMAKE_C_COMPILER_ID STREQUAL "GNU")
    string(APPEND CMAKE_SHARED_LINKER_FLAGS " " "-Wl,--no-undefined")
    string(APPEND CMAKE_MODULE_LINKER_FLAGS " " "-Wl,--no-undefined")
elseif (CMAKE_C_COMPILER_ID MATCHES "Clang")
    string(APPEND CMAKE_SHARED_LINKER_FLAGS " " "-Wl,-undefined,error")
    string(APPEND CMAKE_MODULE_LINKER_FLAGS " " "-Wl,-undefined,error")
endif()

# Platform definitions used in config.h
#
if (WIN32)
    set(SAIL_WIN32 ON)
endif()

if (UNIX)
    set(SAIL_UNIX ON)
endif()

if (MINGW)
    set(SAIL_MINGW ON)
endif()

if (CYGWIN)
    set(SAIL_CYGWIN ON)
endif()

if (APPLE)
    set(SAIL_APPLE ON)
endif()

# Codecs & icons paths
#
set(SAIL_CODECS_PATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/sail/codecs")
if (WIN32)
    string(REPLACE "/" "\\\\" SAIL_CODECS_PATH "${SAIL_CODECS_PATH}")
endif()

# Global include directory with generated configs
#
include_directories("${PROJECT_BINARY_DIR}/include")

# Configure subdirs
#
add_subdirectory(src/sail-common)
add_subdirectory(src/sail-codecs)
if (SAIL_COMBINE_CODECS)
    add_subdirectory(src/sail-codecs-archive)
endif()
add_subdirectory(src/sail)
add_subdirectory(src/sail-manip)
add_subdirectory(src/bindings/sail-c++)

if (SAIL_BUILD_APPS)
    add_subdirectory(examples/c/sail)
endif()

if (SAIL_BUILD_EXAMPLES)
    find_package(SDL2)
    set(SAIL_SDL_EXAMPLE OFF)

    if (SDL2_FOUND)
        set(SAIL_SDL_EXAMPLE ON)
        add_subdirectory(examples/c/sail-sdl-viewer)
    endif()
endif()

if (BUILD_TESTING)
    add_subdirectory(tests)
endif()

# Error check: This particular build of SAIL cannot load any image
#
if (NOT ENABLED_CODECS AND NOT SAIL_THIRD_PARTY_CODECS_PATH)
    message(FATAL_ERROR "No codecs are enabled and SAIL_THIRD_PARTY_CODECS_PATH is disabled.\nThis particular build of SAIL cannot load any image.")
endif()

# Install our bundled libs if they exist and when VCPKG is not used
#
if (NOT SAIL_VCPKG)
    # When SAIL_COMBINE_CODECS is ON, sail-codecs.dll directly depends on extra libs.
    # Copy them into the bin directory. Otherwise, client applications will fail to run.
    #
    # When SAIL_COMBINE_CODECS is OFF, SAIL loads codecs in runtime. In this case we can put
    # extra libs in a separate directory and update the DLL search path.
    #
    if (SAIL_COMBINE_CODECS)
        set(SAIL_EXTRA_LIBS_INSTALL_PATH "bin")
    else()
        set(SAIL_EXTRA_LIBS_INSTALL_PATH "lib/sail/codecs/lib")
    endif()

    if (WIN32)
        if (EXISTS "${PROJECT_SOURCE_DIR}/extra/B/bin")
            install(DIRECTORY "${PROJECT_SOURCE_DIR}/extra/B/bin/" DESTINATION ${SAIL_EXTRA_LIBS_INSTALL_PATH})
        endif()
        if (EXISTS "${PROJECT_SOURCE_DIR}/extra/B/share/sail/licenses")
            install(DIRECTORY "${PROJECT_SOURCE_DIR}/extra/B/share/sail/licenses/" DESTINATION share/sail/licenses)
        endif()
    else()
        if (EXISTS "${PROJECT_SOURCE_DIR}/extra/B/lib")
            install(DIRECTORY "${PROJECT_SOURCE_DIR}/extra/B/lib/" DESTINATION ${SAIL_EXTRA_LIBS_INSTALL_PATH})
        endif()
    endif()
endif()

if (ENABLED_CODECS)
    string(TOUPPER "${ENABLED_CODECS}" ENABLED_CODECS)

    foreach (codec IN LISTS ENABLED_CODECS)
        set(SAIL_HAVE_CODEC_DEFINES "${SAIL_HAVE_CODEC_DEFINES}#define SAIL_HAVE_BUILTIN_${codec}\n")
    endforeach()

    string(REPLACE ";" " " ENABLED_CODECS "${ENABLED_CODECS}")
endif()

if (DISABLED_CODECS)
    string(TOUPPER "${DISABLED_CODECS}" DISABLED_CODECS)
    string(REPLACE ";" " " DISABLED_CODECS "${DISABLED_CODECS}")
endif()

# Common configuration file
#
configure_file("${PROJECT_SOURCE_DIR}/src/config.h.in" "${PROJECT_BINARY_DIR}/include/sail-common/config.h" @ONLY)
install(FILES "${PROJECT_BINARY_DIR}/include/sail-common/config.h" DESTINATION include/sail/sail-common)

# Print configuration statistics
#
if (SAIL_COLORED_OUTPUT)
    set(SAIL_COLORED_OUTPUT_CLARIFY " (on Windows >= 10 and Unix)")
endif()

message("")
message("***************************************")
message("*")
message("* Configuration statistics: ")
message("*")
message("* CMake version:                ${CMAKE_VERSION}")
message("* CMake C flags:                ${CMAKE_C_FLAGS}")
message("* CMake CXX flags:              ${CMAKE_CXX_FLAGS}")
message("* CMake shared link flags:      ${CMAKE_SHARED_LINKER_FLAGS}")
message("* CMake static link flags:      ${CMAKE_STATIC_LINKER_FLAGS}")
message("* CMake module link flags:      ${CMAKE_MODULE_LINKER_FLAGS}")
message("*")
message("* SAIL version:                 ${PROJECT_VERSION}")
message("* Developer mode:               ${SAIL_DEV}")
message("* VCPKG mode:                   ${SAIL_VCPKG}")
message("* Shared build:                 ${BUILD_SHARED_LIBS}")
message("*   Combine codecs [*]:         ${SAIL_COMBINE_CODECS}")
message("* Thread-safe:                  ${SAIL_THREAD_SAFE}")
message("* SAIL_THIRD_PARTY_CODECS_PATH: ${SAIL_THIRD_PARTY_CODECS_PATH}")
message("* Colored output:               ${SAIL_COLORED_OUTPUT}${SAIL_COLORED_OUTPUT_CLARIFY}")
message("* Build apps:                   ${SAIL_BUILD_APPS}")
message("* Build examples:               ${SAIL_BUILD_EXAMPLES}")
message("* Build SDL example:            ${SAIL_SDL_EXAMPLE}")
message("* Build tests:                  ${BUILD_TESTING}")
message("* Install PDB files:            ${SAIL_INSTALL_PDB}")
message("*")
message("* SAIL_HAVE_BUILTIN_BSWAP16:    ${SAIL_HAVE_BUILTIN_BSWAP16_DISPLAY}")
message("* SAIL_HAVE_BUILTIN_BSWAP32:    ${SAIL_HAVE_BUILTIN_BSWAP32_DISPLAY}")
message("* SAIL_HAVE_BUILTIN_BSWAP64:    ${SAIL_HAVE_BUILTIN_BSWAP64_DISPLAY}")
message("* SAIL_HAVE_OPENMP:             ${SAIL_HAVE_OPENMP_DISPLAY}")
message("* SAIL_OPENMP_SCHEDULE:         ${SAIL_OPENMP_SCHEDULE}")
message("* SAIL_OPENMP_FLAGS:            ${SAIL_OPENMP_FLAGS}")

=== src/sail-codecs/svg/CMakeLists.txt ===
find_library(RESVG_LIBRARY resvg)
find_path(RESVG_INCLUDE_DIRS resvg.h)

# Check the ReSVG version is fresh enough
#
if (RESVG_LIBRARY AND RESVG_INCLUDE_DIRS)
    cmake_push_check_state(RESET)
        set(CMAKE_REQUIRED_INCLUDES ${RESVG_INCLUDE_DIRS})
        set(CMAKE_REQUIRED_LIBRARIES ${RESVG_LIBRARY})

        check_c_source_compiles(
            "
            #include <resvg.h>

            int main(int argc, char *argv[]) {
                resvg_options *resvg_options = resvg_options_create();
                return 0;
            }
        "
        HAVE_RESVG_OPTIONS_CREATE
        )
    cmake_pop_check_state()

    if (HAVE_RESVG_OPTIONS_CREATE)
        set(SAIL_RESVG ON)

        cmake_push_check_state(RESET)
            set(CMAKE_REQUIRED_INCLUDES ${RESVG_INCLUDE_DIRS})

            check_c_source_compiles(
                "
                #include <resvg.h>

                int main(int argc, char *argv[]) {
                    resvg_fit_to resvg_fit_to = { RESVG_FIT_TO_ORIGINAL, 0 };
                    return 0;
                }
            "
            HAVE_RESVG_FIT_TO
            )
        cmake_pop_check_state()

        set(SVG_LIBRARY ${RESVG_LIBRARY})
        set(SVG_INCLUDE_DIRS ${RESVG_INCLUDE_DIRS})

        # This will add the following CMake rules to the CMake config for static builds so a client
        # application links against the required dependencies:
        #
        # find_library(resvg_RELEASE_LIBRARY NAMES resvg)
        # find_library(resvg_DEBUG_LIBRARY NAMES resvg)
        # set_property(TARGET SAIL::sail-codecs APPEND PROPERTY INTERFACE_LINK_LIBRARIES $<$<CONFIG:Release>:${resvg_RELEASE_LIBRARY}> $<$<CONFIG:Debug>:${resvg_DEBUG_LIBRARY}>)
        #
        set(SAIL_CODECS_FIND_DEPENDENCIES ${SAIL_CODECS_FIND_DEPENDENCIES} "find_library,resvg,resvg" PARENT_SCOPE)
    endif()
endif()

# Fall back to NanoSVG
#
if (NOT SAIL_RESVG)
    # Don't use SAIL_CODEC_SVG_REQUIRED_OPTION as it requires CMake 3.18
    #
    find_path(NANOSVG_INCLUDE_DIRS nanosvg/nanosvg.h)

    if (NANOSVG_INCLUDE_DIRS)
        set(SVG_INCLUDE_DIRS ${NANOSVG_INCLUDE_DIRS})
    else()
        if (SAIL_CODEC_SVG_REQUIRED_OPTION STREQUAL "REQUIRED")
            message(FATAL_ERROR "SVG: Missing dependencies (ReSVG or NanoSVG)")
        else()
            return()
        endif()
    endif()
endif()

# Common codec configuration
#
sail_codec(NAME svg
            SOURCES svg.c
            ICON svg.png
            DEPENDENCY_INCLUDE_DIRS ${SVG_INCLUDE_DIRS}
            DEPENDENCY_LIBS ${SVG_LIBRARY})

if (SAIL_RESVG)
    target_compile_definitions(${SAIL_CODEC_TARGET} PRIVATE SAIL_RESVG)

    if (HAVE_RESVG_FIT_TO)
        target_compile_definitions(${SAIL_CODEC_TARGET} PRIVATE SAIL_HAVE_RESVG_FIT_TO)
    endif()
else()
    target_compile_definitions(${SAIL_CODEC_TARGET} PRIVATE SAIL_NANOSVG)
endif()

=== debian/changelog ===
sail (0.9.5-1) unstable; urgency=medium

  * New upstream version 0.9.5
    - Update symbols.
    - Update copyright.
  * Update missing dependencies. (Closes: #1060734)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 24 May 2024 21:33:22 +0100

sail (0.9.0+repack-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062882

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 15:41:43 +0000

=== debian/control ===
Source: sail
Section: libs
Priority: optional
Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
Rules-Requires-Root: no
Build-Depends: dpkg-dev (>= 1.22.5),
 debhelper-compat (= 13), libgif-dev, libjpeg-dev, cmake,
 libpng-dev, libtiff-dev, libavif-dev, libwebp-dev, libjxl-dev
Standards-Version: 4.6.2
Homepage: https://github.com/HappySeaFox/sail
Vcs-Browser: https://salsa.debian.org/sudip/sail
Vcs-Git: https://salsa.debian.org/sudip/sail.git

Package: libsail-common0t64
Provides: ${t64:Provides}
Replaces: libsail-common0
Breaks: libsail-common0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SAIL common client library (shared library)
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package contains the shared library.

Package: libsail-common-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsail-common0t64 (= ${binary:Version}), ${misc:Depends}
Description: SAIL common client library (development files)
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package is needed to compile programs against libsail-common0.

Package: libsail-manip0t64
Provides: ${t64:Provides}
Replaces: libsail-manip0
Breaks: libsail-manip0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SAIL image manipulation library (shared library)
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package provides image manipulation functions.
 .
 This package contains the shared library.

Package: libsail-manip-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsail-manip0t64 (= ${binary:Version}), ${misc:Depends}
Description: SAIL image manipulation library (development files)
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package is needed to compile programs against libsail-manip0.

Package: libsail0t64
Provides: ${t64:Provides}
Replaces: libsail0
Breaks: libsail0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, sail-codecs (= ${binary:Version})
Description: SAIL client library (shared library)
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package provides high-level SAIL client libraries.
 .
 This package contains the shared library.

Package: libsail-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libsail0t64 (= ${binary:Version}),
 ${misc:Depends},
 libsail-common-dev
Description: SAIL client library (development files)
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package provides high-level SAIL development headers and libraries.

Package: libsail-c++0t64
Provides: ${t64:Provides}
Replaces: libsail-c++0
Breaks: libsail-c++0 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SAIL C++ client library (shared library)
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package provides high-level SAIL client libraries.

Package: libsail-c++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libsail-c++0t64 (= ${binary:Version}),
 ${misc:Depends},
 libsail-dev,
 libsail-manip-dev
Description: SAIL C++ client library (development files)
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package provides high-level SAIL C++ development headers and libraries.

Package: sail-codecs
Architecture: any
Multi-Arch: same
Section: misc
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SAIL common image codecs
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package provides low-level SAIL image codecs.

## sail 0.9.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -76,6 +76,7 @@
 # Options
 #
 option(SAIL_BUILD_APPS "Build applications." ON)
+option(SAIL_BUILD_BINDINGS "Build the C++ and other bindings." ON)
 option(SAIL_BUILD_EXAMPLES "Build examples." ON)
 option(SAIL_DEV "Enable developer mode. Be more strict when compiling source code, for example." OFF)
 option(SAIL_ENABLE_OPENMP "Enable OpenMP support if it's available in the compiler." ON)
@@ -193,20 +194,20 @@
     set(SAIL_WIN32 ON)
 endif()
 
+if (MINGW)
+    set(SAIL_MINGW ON)
+endif()
+
+if (CYGWIN)
+    set(SAIL_CYGWIN ON)
+endif()
+
+if (APPLE)
+    set(SAIL_APPLE ON)
+endif()
+
 if (UNIX)
     set(SAIL_UNIX ON)
-endif()
-
-if (MINGW)
-    set(SAIL_MINGW ON)
-endif()
-
-if (CYGWIN)
-    set(SAIL_CYGWIN ON)
-endif()
-
-if (APPLE)
-    set(SAIL_APPLE ON)
 endif()
 
 # Codecs & icons paths
@@ -229,7 +230,9 @@
 endif()
 add_subdirectory(src/sail)
 add_subdirectory(src/sail-manip)
-add_subdirectory(src/bindings/sail-c++)
+if (SAIL_BUILD_BINDINGS)
+  add_subdirectory(src/bindings/sail-c++)
+endif()
 
 if (SAIL_BUILD_APPS)
     add_subdirectory(examples/c/sail)
@@ -333,6 +336,7 @@
 message("* Build apps:                   ${SAIL_BUILD_APPS}")
 message("* Build examples:               ${SAIL_BUILD_EXAMPLES}")
 message("* Build SDL example:            ${SAIL_SDL_EXAMPLE}")
+message("* Build bindings:               ${SAIL_BUILD_BINDINGS}")
 message("* Build tests:                  ${BUILD_TESTING}")
 message("* Install PDB files:            ${SAIL_INSTALL_PDB}")
 message("*")
@@ -340,5 +344,3 @@
 message("* SAIL_HAVE_BUILTIN_BSWAP32:    ${SAIL_HAVE_BUILTIN_BSWAP32_DISPLAY}")
 message("* SAIL_HAVE_BUILTIN_BSWAP64:    ${SAIL_HAVE_BUILTIN_BSWAP64_DISPLAY}")
 message("* SAIL_HAVE_OPENMP:             ${SAIL_HAVE_OPENMP_DISPLAY}")
-message("* SAIL_OPENMP_SCHEDULE:         ${SAIL_OPENMP_SCHEDULE}")
-message("* SAIL_OPENMP_FLAGS:            ${SAIL_OPENMP_FLAGS}")

=== debian/changelog ===
sail (0.9.6-1) unstable; urgency=medium

  * New upstream version 0.9.6
  * Update Standards-Version to 4.7.0

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 14 Oct 2024 21:02:21 +0100

## sail 0.9.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.12)
 
-project(SAIL VERSION 0.9.5
+project(SAIL VERSION 0.9.7
              DESCRIPTION "Squirrel Abstract Image Library"
              LANGUAGES C CXX)

=== tests/sail-common/CMakeLists.txt ===
sail_test(TARGET bytes-per-line      SOURCES bytes_per_line.c      LINK sail-common)
sail_test(TARGET compare-pixel-sizes SOURCES compare_pixel_sizes.c LINK sail-common)
sail_test(TARGET hash-map            SOURCES hash_map.c            LINK sail-common sail-comparators)
sail_test(TARGET hex-data            SOURCES hex_data.c            LINK sail-common)
sail_test(TARGET iccp                SOURCES iccp.c                LINK sail-common)
sail_test(TARGET integrity           SOURCES integrity.c           LINK sail-common)
sail_test(TARGET load-options        SOURCES load_options.c        LINK sail-common)
sail_test(TARGET malloc              SOURCES malloc.c              LINK sail-common)
sail_test(TARGET meta-data           SOURCES meta_data.c           LINK sail-common sail-comparators)
sail_test(TARGET palette             SOURCES palette.c             LINK sail-common)
sail_test(TARGET save-options        SOURCES save_options.c        LINK sail-common)
sail_test(TARGET utils               SOURCES utils.c               LINK sail-common)
sail_test(TARGET variant             SOURCES variant.c             LINK sail-common)

=== examples/c/sail-sdl-viewer/CMakeLists.txt ===
add_executable(sail-sdl-viewer sail-sdl-viewer.c)

# Add SDL2 dependencies
#
if (SAIL_VCPKG)
    if (UNIX)
        target_link_libraries(sail-sdl-viewer PRIVATE SDL2::SDL2-static SDL2::SDL2main)
    else()
        target_link_libraries(sail-sdl-viewer PRIVATE SDL2::SDL2 SDL2::SDL2main)
    endif()
else()
    # On OSX and brew, SDL2_INCLUDE_DIRS points to .../SDL2 which makes impossible
    # inclusion of SDL2/SDL.h. For some reason, /usr/local/include is not included
    # into the search paths, so we do it explicitly.
    #
    if (APPLE)
        find_path(SAIL_SDL2_INCLUDE_DIR NAMES SDL2/SDL.h)
        target_include_directories(sail-sdl-viewer PRIVATE ${SAIL_SDL2_INCLUDE_DIR})
    endif()

    # Some SDL2 configs export SDL2::SDL2, some ${SDL2_LIBRARIES}
    #
    if (TARGET SDL2::SDL2)
        target_link_libraries(sail-sdl-viewer PRIVATE SDL2::SDL2)
    else()
        # Strip whitespaces.
        #
        # Some SDL2 versions have buggy CMake config with extra whitespaces.
        # Configuration can fail with:
        #
        #   Target "sail-sdl-viewer" links to item "-L/usr/lib/x86_64-linux-gnu -lSDL2
        #   " which has leading or trailing whitespace.  This is now an error according
        #   to policy CMP0004.
        #
        string(STRIP ${SDL2_LIBRARIES} SDL2_LIBRARIES)

        target_include_directories(sail-sdl-viewer PRIVATE ${SDL2_INCLUDE_DIRS})
        target_link_libraries(sail-sdl-viewer PRIVATE ${SDL2_LIBRARIES})
    endif()
endif()

# Depend on sail
#
target_link_libraries(sail-sdl-viewer PRIVATE sail)

# Depend on sail-manip
#
target_link_libraries(sail-sdl-viewer PRIVATE sail-manip)

# Enable ASAN if possible
#
sail_enable_asan(TARGET sail-sdl-viewer)

=== src/sail-codecs/gif/CMakeLists.txt ===
find_package(GIF ${SAIL_CODEC_GIF_REQUIRED_OPTION})

if (NOT GIF_FOUND)
    return()
endif()

# This will add the following CMake rules to the CMake config for static builds so a client
# application links against the required dependencies:
#
# find_dependency(GIF REQUIRED)
# set_property(TARGET SAIL::sail-codecs APPEND PROPERTY INTERFACE_LINK_LIBRARIES GIF::GIF)
#
set(SAIL_CODECS_FIND_DEPENDENCIES ${SAIL_CODECS_FIND_DEPENDENCIES} "find_dependency,GIF,GIF::GIF" PARENT_SCOPE)

# Common codec configuration
#
sail_codec(NAME gif
            SOURCES helpers.h helpers.c io.h io.c gif.c
            ICON gif.png
            DEPENDENCY_INCLUDE_DIRS ${GIF_INCLUDE_DIRS}
            DEPENDENCY_LIBS ${GIF_LIBRARIES})

=== debian/changelog ===
sail (0.9.7-1build1) plucky; urgency=medium

  * Rebuild against latest jpeg-xl

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sat, 08 Feb 2025 14:44:36 -0500

sail (0.9.7-1) unstable; urgency=medium

  * New upstream version 0.9.7

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 24 Dec 2024 14:02:30 +0000

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: dpkg-dev (>= 1.22.5),
  debhelper-compat (= 13), libgif-dev, libjpeg-dev, cmake,
  libpng-dev, libtiff-dev, libavif-dev, libwebp-dev, libjxl-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/HappySeaFox/sail
 Vcs-Browser: https://salsa.debian.org/sudip/sail
 Vcs-Git: https://salsa.debian.org/sudip/sail.git

## sail 0.9.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.12)
 
-project(SAIL VERSION 0.9.7
+project(SAIL VERSION 0.9.8
              DESCRIPTION "Squirrel Abstract Image Library"
              LANGUAGES C CXX)

=== tests/CMakeLists.txt ===
# Test images
#
set(SAIL_TEST_IMAGES_PATH ${CMAKE_CURRENT_SOURCE_DIR}/images)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/images/test-images.h.in ${PROJECT_BINARY_DIR}/include/test-images.h @ONLY)

# Dependencies
#
add_subdirectory(munit)
add_subdirectory(sail-comparators)
add_subdirectory(sail-dump)

# Actual tests
#
add_subdirectory(sail-common)
add_subdirectory(sail)
add_subdirectory(sail-manip)
if (SAIL_BUILD_BINDINGS)
  add_subdirectory(bindings/c++)
endif()

=== src/sail-codecs/avif/CMakeLists.txt ===
find_package(libavif CONFIG ${SAIL_CODEC_AVIF_REQUIRED_OPTION})

if (NOT libavif_FOUND)
    return()
endif()

# This will add the following CMake rules to the CMake config for static builds so a client
# application links against the required dependencies:
#
# find_dependency(LIBAVIF REQUIRED)
# set_property(TARGET SAIL::sail-codecs APPEND PROPERTY INTERFACE_LINK_LIBRARIES avif)
#
set(SAIL_CODECS_FIND_DEPENDENCIES ${SAIL_CODECS_FIND_DEPENDENCIES} "find_dependency,libavif,avif" PARENT_SCOPE)

# Common codec configuration
#
sail_codec(NAME avif
            SOURCES helpers.h helpers.c io.h io.c avif.c
            ICON avif.png
            DEPENDENCY_LIBS avif)

=== src/sail-codecs/tiff/CMakeLists.txt ===
find_package(TIFF ${SAIL_CODEC_TIFF_REQUIRED_OPTION})

if (NOT TIFF_FOUND)
    return()
endif()

# This will add the following CMake rules to the CMake config for static builds so a client
# application links against the required dependencies:
#
# find_dependency(TIFF REQUIRED)
# set_property(TARGET SAIL::sail-codecs APPEND PROPERTY INTERFACE_LINK_LIBRARIES TIFF::TIFF)
#
set(SAIL_CODECS_FIND_DEPENDENCIES ${SAIL_CODECS_FIND_DEPENDENCIES} "find_dependency,TIFF,TIFF::TIFF" PARENT_SCOPE)

# Check for TIFF features
set(TIFF_CODECS ADOBE_DEFLATE CCITTRLE CCITTRLEW CCITT_T4 CCITT_T6 DCS DEFLATE IT8BL IT8CTPAD IT8LW IT8MP
                JBIG JPEG JP2000 JXL LERC LZMA LZW NEXT NONE OJPEG PACKBITS PIXARFILM PIXARLOG SGILOG24 SGILOG
                T43 T85 THUNDERSCAN WEBP ZSTD)

foreach (tiff_codec IN LISTS TIFF_CODECS)
    # Check compression definitions
    #
    cmake_push_check_state(RESET)
        set(CMAKE_REQUIRED_INCLUDES ${TIFF_INCLUDE_DIRS})

        check_c_source_compiles(
            "
            #include <tiff.h>

            int main(int argc, char *argv[]) {
                int compression = COMPRESSION_${tiff_codec};
                return 0;
            }
        "
        HAVE_TIFF_${tiff_codec}
        )
    cmake_pop_check_state()

    # Check if we can actually save defined compressions
    #
    if (SAIL_VCPKG OR CMAKE_CROSSCOMPILING)
        # Enable compression and hope for the best. The reason is that check_c_source_runs()
        # fails in VCPKG or cross-compilation mode.
        #
        # For VCPKG, it fails as it cannot find tiff.dll, see https://github.com/microsoft/vcpkg/issues/16793
        #
        message("-- Skipping Test and Explicitly Enabling HAVE_TIFF_WRITE_${tiff_codec}")
        set(HAVE_TIFF_WRITE_${tiff_codec} ON)
    else()
        cmake_push_check_state(RESET)
            set(CMAKE_REQUIRED_INCLUDES ${TIFF_INCLUDE_DIRS})
            set(CMAKE_REQUIRED_LIBRARIES ${TIFF_LIBRARIES})

            check_c_source_runs(
                "
                #include <stdlib.h>
                #include <string.h>
                #include <tiffio.h>

                int main(int argc, char *argv[]) {

                    TIFF *tiff = TIFFOpen(\"${CMAKE_CURRENT_BINARY_DIR}/file.tiff\", \"w\");

                    if (tiff == NULL) {
                        return 1;
                    }

                    /*
                     * This check is not quite correct as some codecs may not support
                     * these parameters. For example, JBIG doesn't support RGBA.
                     */
                    TIFFSetField(tiff, TIFFTAG_IMAGEWIDTH,  1);
                    TIFFSetField(tiff, TIFFTAG_IMAGELENGTH, 1);
                    TIFFSetField(tiff, TIFFTAG_ORIENTATION, ORIENTATION_TOPLEFT);
                    TIFFSetField(tiff, TIFFTAG_SAMPLESPERPIXEL, 4);
                    TIFFSetField(tiff, TIFFTAG_BITSPERSAMPLE, 8);
                    TIFFSetField(tiff, TIFFTAG_PLANARCONFIG, PLANARCONFIG_CONTIG);
                    TIFFSetField(tiff, TIFFTAG_PHOTOMETRIC, PHOTOMETRIC_RGB);
                    TIFFSetField(tiff, TIFFTAG_COMPRESSION, COMPRESSION_${tiff_codec});
                    TIFFSetField(tiff, TIFFTAG_ROWSPERSTRIP, TIFFDefaultStripSize(tiff, (uint32)-1));

                    unsigned char scan[4];
                    memset(scan, 255, sizeof(scan));

                    if (TIFFWriteScanline(tiff, scan, 0, 0) < 0) {
                        return 2;
                    }

                    TIFFClose(tiff);

                    return 0;
                }
            "
            HAVE_TIFF_WRITE_${tiff_codec}
            )
        cmake_pop_check_state()
    endif()

    if (HAVE_TIFF_WRITE_${tiff_codec})
        # Match the SAIL namings
        #
        string(REPLACE "_"         "-"          tiff_codec_fixed ${tiff_codec})
        string(REPLACE "CCITTRLE"  "CCITT-RLE"  tiff_codec_fixed ${tiff_codec_fixed})
        string(REPLACE "CCITTRLEW" "CCITT-RLEW" tiff_codec_fixed ${tiff_codec_fixed})
        string(REPLACE "IT8BL"     "IT8-BL"     tiff_codec_fixed ${tiff_codec_fixed})
        string(REPLACE "IT8CTPAD"  "IT8-CTPAD"  tiff_codec_fixed ${tiff_codec_fixed})
        string(REPLACE "IT8LW"     "IT8-LW"     tiff_codec_fixed ${tiff_codec_fixed})
        string(REPLACE "IT8MP"     "IT8-MP"     tiff_codec_fixed ${tiff_codec_fixed})
        string(REPLACE "JP2000"    "JPEG-2000"  tiff_codec_fixed ${tiff_codec_fixed})
        string(REPLACE "JXL"       "JPEG-XL"    tiff_codec_fixed ${tiff_codec_fixed})
        string(REPLACE "PIXARLOG"  "PIXAR-LOG"  tiff_codec_fixed ${tiff_codec_fixed})
        string(REPLACE "PIXARFILM" "PIXAR-FILM" tiff_codec_fixed ${tiff_codec_fixed})
        string(REPLACE "SGILOG24"  "SGI-LOG24"  tiff_codec_fixed ${tiff_codec_fixed})
        string(REPLACE "SGILOG"    "SGI-LOG"    tiff_codec_fixed ${tiff_codec_fixed})

        # Used in .codec.info
        #
        list(APPEND TIFF_CODEC_INFO_COMPRESSIONS ${tiff_codec_fixed})
    endif()
endforeach()

# Default compression. Used in .codec.info
#
if (JPEG IN_LIST TIFF_CODEC_INFO_COMPRESSIONS)
    set(TIFF_CODEC_INFO_DEFAULT_COMPRESSION JPEG)
else()
    set(TIFF_CODEC_INFO_DEFAULT_COMPRESSION NONE)
endif()

# Common codec configuration
#
sail_codec(NAME tiff
            SOURCES helpers.h helpers.c io.h io.c tiff.c
            ICON tiff.png
            DEPENDENCY_INCLUDE_DIRS ${TIFF_INCLUDE_DIRS}
            DEPENDENCY_LIBS ${TIFF_LIBRARIES})

foreach (tiff_codec IN LISTS TIFF_CODECS)
    if (HAVE_TIFF_${tiff_codec})
        target_compile_definitions(${SAIL_CODEC_TARGET} PRIVATE SAIL_HAVE_TIFF_${tiff_codec})
    endif()

    if (HAVE_TIFF_WRITE_${tiff_codec})
        target_compile_definitions(${SAIL_CODEC_TARGET} PRIVATE SAIL_HAVE_TIFF_WRITE_${tiff_codec})
    endif()
endforeach()

=== tests/bindings/c++/CMakeLists.txt ===
sail_test(TARGET can-load-c++       SOURCES can-load.cpp       LINK sail-c++)
sail_test(TARGET iccp-c++           SOURCES iccp.cpp           LINK sail-c++)
sail_test(TARGET image-c++          SOURCES image.cpp          LINK sail-c++)
sail_test(TARGET load-features-c++  SOURCES load_features.cpp  LINK sail-c++)
sail_test(TARGET load-options-c++   SOURCES load_options.cpp   LINK sail-c++)
sail_test(TARGET meta-data-c++      SOURCES meta_data.cpp      LINK sail-c++)
sail_test(TARGET palette-c++        SOURCES palette.cpp        LINK sail-c++)
sail_test(TARGET save-features-c++  SOURCES save_features.cpp  LINK sail-c++)
sail_test(TARGET save-options-c++   SOURCES save_options.cpp   LINK sail-c++)
sail_test(TARGET utils-c++          SOURCES utils.cpp          LINK sail-c++)
sail_test(TARGET variant-c++        SOURCES variant.cpp        LINK sail-c++)

=== src/sail-codecs/common/bmp/CMakeLists.txt ===
add_library(bmp-common OBJECT
                helpers.h
                helpers.c
                bmp.h
                bmp.c)

target_include_directories(bmp-common PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/../..)

target_link_libraries(bmp-common PRIVATE sail-common)

=== debian/changelog ===
sail (0.9.8-1+deb13u1) trixie; urgency=medium

  * Add upstream patches to fix security vulnerabilities. (Closes: #1112346)
    - CVE-2025-32468
    - CVE-2025-35984
    - CVE-2025-46407
    - CVE-2025-50129
    - CVE-2025-52456
    - CVE-2025-52930
    - CVE-2025-53085
    - CVE-2025-53510

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 02 Nov 2025 21:13:55 +0000

sail (0.9.8-1) unstable; urgency=medium

  * New upstream version 0.9.8
  * Update Standards-Version to 4.7.2

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 06 Apr 2025 12:41:53 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: dpkg-dev (>= 1.22.5),
  debhelper-compat (= 13), libgif-dev, libjpeg-dev, cmake,
  libpng-dev, libtiff-dev, libavif-dev, libwebp-dev, libjxl-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/HappySeaFox/sail
 Vcs-Browser: https://salsa.debian.org/sudip/sail
 Vcs-Git: https://salsa.debian.org/sudip/sail.git
